package com.bocloud.ims.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * HMC服务器
 *
 * @author sxp
 * @since May 22, 2018
 */
@EqualsAndHashCode
@Data
public class HmcServer  {

    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtCreate;
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtModify;
    private Long creatorId;
    private Long ownerId;
    private Long menderId;
    private String name;
    private String status;
    private Boolean deleted;
    private String props;
    private String remark;

    private Long id;

    private String uuid;

    private String referenceCode;

    private String systemFirmware;

    private String activatedLevel;

    private String machineType;

    private String model;

    private String serialNumber;

    private Integer maximumPartitions;

    private String physicalSystemAttentionLedState;

    private String primaryIpAddress;

    private String hostname;

    private String serviceProcessorVersion;

    private String manufacturingDefaultConfigurationEnabled;

    private Long vendorId;

    private String machineTypeAndModel;

    private Double processorUnits;

    private Long systemMemory;

    private Double systemMemoryGB;

    private HmcPartition servicePartition;

    //用于cms监控
    private String thresholdGroupName;//阈值组

    private String policyName;//分发策略

    private Long ruleRelationId;//关联关系id

    private Long thresholdGroupId;  //阈值组ID

    private Long policyId; //分发策略ID


}
