package com.bocloud.mcs.controller;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.utils.TPSCounter;
import com.bocloud.mcs.common.SystemTool;
import com.bocloud.service.core.CurrentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * 系统状态信息
 *
 * @author dmw
 */
@RestController
@RequestMapping("/")
public class IndexController {

    @Autowired
    private CurrentService service;

    @RequestMapping({"/status"})
    public BocloudResult<Map<String, Object>> status() {
        // 获取instance
        String instance = this.service.getService().getHost() + ":" + this.service.getService().getPort();
        SystemTool systemTool = new SystemTool();
        BocloudResult<Map<String, Object>> result = systemTool.status();
        Map<String, Object> status = result.getData();
        status.put("isLeader", this.service.isLeader());
        status.put("current.qps", TPSCounter.tps);
        status.put("instance", instance);
        status.put("service.name", this.service.getService().getName());
        result.setData(status);
        return result;
    }
}
