package com.bocloud.mcs.controller;

import java.io.File;
import java.io.IOException;
import java.util.Collections;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.FileUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import io.prometheus.client.CollectorRegistry;
import io.prometheus.client.exporter.common.TextFormat;

@RestController
public class MetricController {
    private final CollectorRegistry collectorRegistry = CollectorRegistry.defaultRegistry;


    @Value("${metrics.sample.path:/home/cmp/prometheus/metrics}")
    private String path;

    @GetMapping("/metrics")
    public void writeRegistry(HttpServletRequest request, HttpServletResponse response) {
        try {
            response.setContentType("text/plain;charset=UTF-8");
            TextFormat.write004(response.getWriter(), collectorRegistry.filteredMetricFamilySamples(Collections.<String>emptySet()));
        } catch (IOException e) {
            // This actually never happens since StringWriter::write() doesn't
            // throw any IOException
            throw new RuntimeException("Writing metrics failed", e);
        }
    }

    @GetMapping("/sample/metrics")
    public void writeRegistry2(HttpServletRequest request, HttpServletResponse response) {
        try {
            response.setContentType("text/plain;charset=UTF-8");
            response.getWriter().write(FileUtils.readFileToString(new File(path), "utf-8"));
        } catch (IOException e) {
            throw new RuntimeException("Writing metrics failed", e);
        }
    }
}
